#+TITLE:
#+AUTHOR:VLEAD
#+DATE:#+SETUPFILE: ./org-templates/level-0.org
#+TAGS: boilerplate(b)
#+EXCLUDE_TAGS: boilerplate
#+OPTIONS: ^:nil
*  Practice Artefact for Red Black Tree
** Features
+ User can insert,search ,delete a node in a red black tree
+ User can visualize the movement of nodes clearly along with viewing the required steps
+ User can control the speed of the animation

* HTML Framework

** Importing required libraries,CSS,Javascript files

+ The css files are initially imported.
+ The required animation libraries are imported
+ The required artefact javascript files are imported.

** Import CSS required by the animated artefacts.

+ Here, we import the CSS required by the animated artefacts.
#+NAME: cssimports
#+BEGIN_SRC html
<!DOCTYPE html>
<html>
	<head>
		<title>
			Red/Black Tree Visualization 
		</title>
		<link rel="stylesheet" href="../css/style.css">
		<link rel="stylesheet" href="../css/jquery-ui-1.8.11.custom.css">
                <link rel="stylesheet" href="https://ds1-iiith.vlabs.ac.in/exp-common-css/common-styles.css">


#+END_SRC

** Javascript Library Imports

+ The animated artefacts use a library to render animated objects on the UI. 

+ Following are the required imports from the library
#+NAME: jslibimports
#+BEGIN_SRC html	
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.8.3/jquery.min.js"></script>
		<script src="http://code.jquery.com/ui/1.9.2/jquery-ui.js"></script>
		<script type = "text/javascript" src = "../js/lib/CustomEvents.js"> </script>
		<script type = "text/javascript" src = "../js/lib/UndoFunctions.js"> </script>
		<script type = "text/javascript" src = "../js/lib/AnimatedObject.js"> </script>
		<script type = "text/javascript" src = "../js/lib/AnimatedLabel.js"> </script>
		<script type = "text/javascript" src = "../js/lib/AnimatedCircle.js"> </script>
		<script type = "text/javascript" src = "../js/lib/HighlightCircle.js"> </script>
		<script type = "text/javascript" src = "../js/lib/Line.js"> </script>
		<script type = "text/javascript" src = "../js/lib/ObjectManager.js"> </script>
		<script type = "text/javascript" src = "../js/lib/AnimationMain.js"> </script>
		<script type = "text/javascript" src = "../js/lib/Algorithm.js"> </script>
		<script type = "text/javascript" src = "../js/RedBlackExercise.js"> </script> 
		<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" 
			integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
	 </head> 
#+END_SRC

** Instruction Box
+ The instruction box above the artefact carries information about how to use the artefact.
+ It has details over how the controls presented on the screen work.
+ A brief description of the usage of artefacts is also provided here.

#+NAME: instructionbox
#+BEGIN_SRC html

	<body onload="init();" class="VisualizationMainPage">

	<div class="instruction-box">
		<button class="collapsible">Instructions</button>
		<div class="content">
			<ul>
				<li>Click generate root to generate the root of the tree</li> 
				<li> Check the value to be inserted next at the bottom</li>
				<li> Choose the next step by clicking the appropriate button</li>
				<li> Click submit to check your answers</li>
				<li> Click show steps to view each steps</li>
				<li> Keep clicking show steps till all the steps are viewed</li>
				<li>You can decrease the <b>speed</b> of the animation by using the <b>animation slider</b>.</li>
				<li>It is recommended that you set the speed to a minimum value to visualize each step properly.</li>
				<li>To <b>insert</b> the an element in the tree, enter the value in the textbox before insert and then <b>click the INSERT button</b>. Follow same approach for other operations as well.</li>
				<li>You can use the <b>Pause</b> button to pause the animation at any point of time.</li>
				<li>After animation has been paused, click on the <b>Step Forward</b> and <b>Step Backward</b> button to step through the animation.</li>
				<li>The <b>Skip Forward</b> and <b>Skip Backward</b> buttons can be used to undo and redo operations after they have been performed on the tree.</li>
			</ul>
		</div> 
	</div>
#+END_SRC		

** Animation controls for controlling the speed

#+NAME: generalanimcontrol
#+BEGIN_SRC html
	<div id = "container">
		<div id = "mainContent">
			<div id = "algoControlSection">
				<div id="AlgorithmSpecificControls" class="form-inline input-group container-fluid" style="padding-left: 0px !important;padding-right: 0px !important;">
					<button style="padding-left: 1% !important;padding-right: 1% !important;" class="button-input" id="control-exer-root">Generate Root</button>
					<button style="padding-left: 1% !important;padding-right: 1% !important;" class="button-input" id="control-exer-insert-l">Insert Left</button>
					<button style="padding-left: 1% !important;padding-right: 1% !important;" class="button-input" id="control-exer-insert-r">Insert Right</button>
					<button style="padding-left: 1% !important;padding-right: 1% !important;" class="button-input" id="control-exer-rotate-l">Insert and Rotate Left</button>
					<button style="padding-left: 1% !important;padding-right: 1% !important;" class="button-input" id="control-exer-rotate-r">Insert and Rotate Right</button>
					<button style="padding-left: 1% !important;padding-right: 1% !important;" class="button-input" id="control-exer-submit">Submit</button>
					<button style="padding-left: 1% !important;padding-right: 1% !important;" class="button-input" id="control-exer-steps">Show Steps</button>
					<button style="padding-left: 1% !important;padding-right: 1% !important;" class="button-input" id="control-exer-reset">Reset</button>
					<label style="display:none;"><input type="checkbox" id="control-exer-null">Show null Leaves</label>
				</div>
			</div>

			<div class="row" style="margin:auto;padding-top:2%;height:15vh;">
				<div class="col-md-7 col-xs-12" style="padding-left: 141px;">
					<div class="comment-box">
						<b>Next Element to be Inserted</b>
						<p id="nextelement"> </p>
					</div>
				</div>
				<div class="col-md-5 col-xs-12">
					<div class="comment-box">
						<b>Observations</b>
						<p id="nextcomment"> </p>
					</div>
				</div>
			</div>

			<div id = "generalAnimationControlSection" style="display:none;">
				<table id="GeneralAnimationControls">  
				</table>		
			</div>
                        <canvas id="canvas" width="1200" height="500" >
			</canvas>
		</div> 
	</div>
	</body>

	<script>
		var collapsibleEl = document.getElementsByClassName("collapsible")[0];
		collapsibleEl.addEventListener("click", function() {
			this.classList.toggle("active");
			var content = this.nextElementSibling;
			if (content.style.maxHeight){
				content.style.maxHeight = null;
			} else {
				content.style.maxHeight = content.scrollHeight + "px";
			} 
		});
	</script>

</html>

#+END_SRC

* Tangle
#+BEGIN_SRC js :tangle redblackexercise.html :eval no :noweb yes
<<cssimports>>
<<jslibimports>>
<<instructionbox>>
<<generalanimcontrol>>
#+END_SRC
